/* $Id: gic_debug.h,v 1.7 2005/07/30 16:57:37 cegger Exp $
******************************************************************************

   LibGIC debugging macros

   Copyright (C) 1998	Marcus Sundberg		[marcus@ggi-project.org]
   Copyright (C) 1999	Andreas Beck		[becka@ggi-project.org]
  
   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#ifndef _GGI_INTERNAL_GIC_DEBUG_H
#define _GGI_INTERNAL_GIC_DEBUG_H

#include <ggi/gic-defs.h>
#include <ggi/internal/debug_macros.h>

#define DEBUG_ISSYNC   (_gicDebug&DEBUG_SYNC)

#define DEBUG_CORE     (1<<1)	/*   2 */
#define DEBUG_MISC     (1<<5)	/*  32 */
#define DEBUG_LIBS     (1<<6)	/*  64 */
#define DEBUG_EVENTS   (1<<7)	/* 128 */

__BEGIN_DECLS

GGIGICAPIVAR uint32_t   _gicDebug;

static inline void DPRINT(const char *form,...)        { DPRINTIF(_gicDebug,DEBUG_ALL);    }
static inline void DPRINT_CORE(const char *form,...)   { DPRINTIF(_gicDebug,DEBUG_CORE);   }
static inline void DPRINT_MISC(const char *form,...)   { DPRINTIF(_gicDebug,DEBUG_MISC);   }
static inline void DPRINT_LIBS(const char *form,...)   { DPRINTIF(_gicDebug,DEBUG_LIBS);   }
static inline void DPRINT_EVENTS(const char *form,...) { DPRINTIF(_gicDebug,DEBUG_EVENTS); }

__END_DECLS

#endif /* _GGI_INTERNAL_GIC_DEBUG_H */
